
/*
 *			  COPYRIGHT 1987
 *		   DIGITAL EQUIPMENT CORPORATION
 *		       MAYNARD, MASSACHUSETTS
 *			ALL RIGHTS RESERVED.
 *
 * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
 * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
 * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE FOR
 * ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
 *
 * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT RIGHTS,
 * APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN ADDITION TO THAT
 * SET FORTH ABOVE.
 *
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Digital Equipment Corporation not be 
 * used in advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.
 */




/**********************************************************************************/
/*                            commands.c                                          */
/*                      based on the old xedit commands.c                         */
/*       modified on 15.11.93 by Sorina COTISEL (cotisel@imag.fr)                 */
/*   Mediatheque IMAG - BP 53X, 38041 GRENOBLE Cedex - mediatheque@imag.fr        */
/*   http://ftpmedia.imag.fr/anteserveur/imag                                     */
/*                                                                                */
/*                                                                                */     
/*   modified on 1.03.94 by Sorina COTISEL for the second version xhtmledit-1.1   */
/*                                                                                */     
/*   - removed functions:  PlaceMenuHypertext(), EndAnchor()                      */
/*   - modified functions: PopupDialog(), DialogDone(), Done(), DialogCancel()    */
/*                         ShowVers(), WriteMessage()                             */
/*                         WriteHypertext() became WriteImgSrc()                  */
/*                         QuitVers() became QuitButton()                         */
/*   - added functions:    PopupWarning()                                         */
/*                         WriteMessage() - it was moved from the util.c module   */
/*                                                                                */
/*   modified on 15.03.94 by Sorina COTISEL for the third version xhtmledit-1.2   */
/*                                                                                */
/*   - added function:     DisplayFile()                                          */
/*   - modified functions: PlaceMenu() , WriteMessage()                           */
/*                                                                                */
/*   corrected errors on 11.04.94 for the xhtmledit-1.2a version                  */
/**********************************************************************************/




#include "xhtmledit.h"
#ifdef CRAY
#include <unistd.h>
#endif

extern Widget textwindow, labelwindow, filenamewindow,messwidget,pshellAnchor;
extern Widget route,popshellAnchor,pshellLocal,pshellNameAnchor,pshellNameRelativ;
extern Widget mark, popshellMark,menupaneMark[N_MARK],menupaneAnchor[N_ANCHOR];
extern Widget file_wid, popshellFile,menupaneFile[N_FILE];
extern Widget pshellGopher,pshellTelnet,pshellNews;
extern Widget pshellFtp,imgsrc;
extern Widget popshellImg,pshellImg,menupaneImg[N_IMG];
extern Widget header,popshellHeader,menupaneHeader[N_HEADER];
extern Widget style,popshellStyle,menupaneStyle[N_STYLE];
extern Widget popshellList,menupaneList[N_LIST],list;
extern Widget popshellAccent,menupaneAccent[N_ACCENT],accent;
extern Widget popshellSpChar,menupaneSpChar[N_SPCHAR],spChar;
extern Widget subshellOther,menupaneOther[N_OTHER];
extern Widget subshellLogicalStyle,menupaneLogicalStyle[N_LSTYLE];
extern Widget pshellVersion,menulabel,cut,vers,checkup, version;
extern Widget pshellWarning,warning;
extern Widget popshellHelp,menupaneHelp[N_HELP],help;
extern Widget popshellDisplay,display,menupaneDisplay[N_DISPLAY];
extern Widget dialogAnchor,dialogFtp,dialogLocal,dialogNews,dialogGopher,dialogTelnet,dialogImg;
extern Widget nameAnchor,nameRel,hypString;
extern Widget top;



String name_anchor,img_string,nameRel_anchor,name_img;
int pane_number,pane_choice,menu;
char test_file[30];

void ResetSourceChanged();

static void ResetDC();

static Boolean double_click = FALSE, source_changed = FALSE;


/* popup dialog boxes (callback function) */

void PopupDialog(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
   int i;
   Position x,y;
   Dimension width, height;
   XawTextPosition start_pos,end_pos;

   XawTextGetSelectionPos(textwindow,&start_pos,&end_pos);

   /* pop up warning if no text is selected */

   if((start_pos == end_pos) && (menu == MENU_ANCHOR))
   {
      PopupWarning();
      return;
   }

   i = (int)client_data;

   /* no application functions are valid while dialog is popped up */

   if (menu == MENU_ANCHOR)
      XtSetSensitive(route, FALSE);
   else if (menu == MENU_IMG)
      XtSetSensitive(imgsrc, FALSE);
 

   /* move popup shell to the coordinates root window and popup the dialog */

   switch(i)
   {
      case 1:  /* dialog box for http */
	 TranslateCoords(route,&x,&y,&height,&width);
         XtVaSetValues(pshellAnchor,XtNx,x+width,XtNy,y+height,NULL);
         XtPopup(pshellAnchor,XtGrabExclusive);
	 break;
      case 2:  /* dialog box for local */
	 TranslateCoords(route,&x,&y,&height,&width);
         XtVaSetValues(pshellLocal,XtNx,x+width,XtNy,y+height,NULL);
         XtPopup(pshellLocal,XtGrabExclusive);
	 break;
      case 3:  /* dialog box for anchor name */
	 TranslateCoords(route,&x,&y,&height,&width);
         XtVaSetValues(pshellNameAnchor,XtNx,x+width,XtNy,y+5*height,NULL);
         XtPopup(pshellNameAnchor,XtGrabExclusive);
	 break;
      case 5:  /* dialog box for anchor relative name */
	 TranslateCoords(route,&x,&y,&height,&width);
         XtVaSetValues(pshellNameRelativ,XtNx,x+width,XtNy,y+height,NULL);
         XtPopup(pshellNameRelativ,XtGrabExclusive);
	 break;
      case 6:  /* dialog box for news */
	 TranslateCoords(route,&x,&y,&height,&width);
         XtVaSetValues(pshellNews,XtNx,x+width,XtNy,y+height,NULL);
         XtPopup(pshellNews,XtGrabExclusive);
	 break;
      case 7:  /* dialog box for gopher */
	 TranslateCoords(route,&x,&y,&height,&width);
         XtVaSetValues(pshellGopher,XtNx,x+width,XtNy,y+height,NULL);
         XtPopup(pshellGopher,XtGrabExclusive);
	 break;
      case 8:  /* dialog box for telnet */
	 TranslateCoords(route,&x,&y,&height,&width);
         XtVaSetValues(pshellTelnet,XtNx,x+width,XtNy,y+height,NULL);
         XtPopup(pshellTelnet,XtGrabExclusive);
	 break;
      case 9:  /* dialog box for ftp */
	 TranslateCoords(route,&x,&y,&height,&width);
         XtVaSetValues(pshellFtp,XtNx,x+width,XtNy,y+height,NULL);
         XtPopup(pshellFtp,XtGrabExclusive);
	 break;
      case 10:  /* dialog box for Img */
	 TranslateCoords(imgsrc,&x,&y,&height,&width);
         XtVaSetValues(pshellImg,XtNx,x+width,XtNy,y+height,NULL);
         XtPopup(pshellImg,XtGrabExclusive);
	 break;
   }
}


/* write the anchor string in final_string */

void WriteAnchor(final_string,str,string)
String final_string;
String str;
String string;
{    
	 if (name_anchor[0] == '\0')
	    sprintf(final_string,"<A HREF=\"%s%s\">",str,string);
         else if((name_anchor[0] != '\0')&&(string[0] != 0))
	    sprintf(final_string,"<A NAME=\"%s\" HREF=\"%s%s\">",
	    name_anchor,str,string);
         else if((name_anchor[0] != '\0')&&(string[0] == '\0'))
	    sprintf(final_string,"<A NAME=\"%s\">",name_anchor);
}



/* Dialog done callback function */

void DialogDone(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{

   Widget dialog;
   String string, final_string,str;
   XawTextPosition pos;

   final_string=(char *)malloc(50);
   dialog = (Widget)client_data;

   XtSetSensitive(route,TRUE); 
   
   switch(pane_number)
   {
      case 0:             /* http */
         XtPopdown(pshellAnchor);
	 str = "http://";
	 break;
      case 1:             /* ftp */
         XtPopdown(pshellFtp);
	 str = "ftp://";
	 break;
      case 2:             /* local */
         XtPopdown(pshellLocal);
	 str = "";  
	 break;
      case 4:             /* news */
         XtPopdown(pshellNews);
	 str = "news:";
	 break;
      case 5:             /* gopher */
         XtPopdown(pshellGopher);
	 str = "gopher://";
	 break;
      case 6:             /* telnet */
         XtPopdown(pshellTelnet);
	 str = "telnet://";
	 break;
   }

   final_string[0] = '\0';
   string = XawDialogGetValueString(dialog);

   WriteAnchor(final_string,str,string);

   WriteMark(final_string,"</A>");

   name_anchor[0] = '\0';
   free(final_string);
      
}

/* write the hypertext string to click on it */

void WriteImgString(final_string)
String final_string;
{
   XawTextPosition pos;

   switch(pane_choice)
   {
	case 0:
	   sprintf(final_string,"<img src=\"http://%s\">",img_string);
           break;
        case 1:
	  sprintf(final_string,"<img src=\"%s\">",img_string);
          break;
    }

  pos =  XawTextGetInsertionPoint(textwindow);
  XeditPrintf(final_string,textwindow,pos);

  img_string[0] = '\0';
}


/* Dialog done callback function */

void Done(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{

   WidgetDone *client;
   char final_string[50];
   XawTextPosition pos;

   client = (WidgetDone *)client_data;
   switch (client->i)
   {
      case 1:  /* anchor_name box */
         name_anchor = XawDialogGetValueString(client->wid);
         XtPopdown(pshellNameAnchor);
         break;

      case 3:  /* relative name anchor */
	 nameRel_anchor = XawDialogGetValueString(client->wid);
	 XtPopdown(pshellNameRelativ);
	 XtSetSensitive(route,TRUE);
	 sprintf(final_string,"<A HREF=\"#%s\">",nameRel_anchor);
	 WriteMark(final_string,"</A>");
	 nameRel_anchor[0] = '\0';
	 break;

      case 4:  /* img box */
	 img_string = XawDialogGetValueString(client->wid);
	 XtPopdown(pshellImg);
	 XtSetSensitive(imgsrc,TRUE);
	 WriteImgString(final_string); 
	 break;

   }
}


/* Dialog cancel callback function */

void DialogCancel(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
   int choice;

   choice = (int)client_data;

   switch(choice)
   {
      case 1:
	 XtPopdown(pshellAnchor);
	 break;
      case 2:
	 XtPopdown(pshellLocal);
	 break;
      case 3:
	 XtPopdown(pshellNameAnchor);
	 name_anchor[0] = '\0';
	 break;
      case 5:
	 XtPopdown(pshellNameRelativ);
	 nameRel_anchor[0] = '\0';
	 break;
      case 6:
	 XtPopdown(pshellNews);
	 break;
      case 7:
	 XtPopdown(pshellGopher);
	 break;
      case 8:
	 XtPopdown(pshellTelnet);
	 break;
      case 9:
	 XtPopdown(pshellFtp);
	 break;
      case 10:
	 XtPopdown(pshellImg);
	 name_img[0] = '\0';
	 break;
   }
  if (menu == MENU_ANCHOR)
     XtSetSensitive(route,TRUE);
  else if (menu == MENU_IMG)
     XtSetSensitive(imgsrc,TRUE);
}



/* Place the  menu , just below his command button */ 

/*ARGUSED*/
void PlaceMenu(w,event,params,num_params)
Widget w;
XEvent *event;
String *params;
Cardinal *num_params;
{
   Position x,y;
   Dimension height,width;
   Widget button_widget;

   button_widget = (Widget)w;
   if (button_widget == route)
   {
         menu = MENU_ANCHOR;
         TranslateCoords(route,&x,&y,&height,&width);
         XtVaSetValues(popshellAnchor,XtNx,x-4,XtNy,y+height,NULL);
   }

   else if (button_widget == file_wid)
   {
      menu = MENU_FILE;
      TranslateCoords(file_wid,&x,&y,&height,&width);
      XtVaSetValues(popshellFile,XtNx,x-4,XtNy,y+height,NULL);
   }

   else if (button_widget == mark)
   {
      menu = MENU_MARK;
      TranslateCoords(mark,&x,&y,&height,&width);
      XtVaSetValues(popshellMark,XtNx,x-4,XtNy,y+height,NULL);
   }
   
   else if (button_widget == imgsrc)
   {
      menu = MENU_IMG;
      TranslateCoords(imgsrc,&x,&y,&height,&width);
      XtVaSetValues(popshellImg,XtNx,x-4,XtNy,y+height,NULL);
   }

   else if (button_widget == header)
   {
      menu = MENU_HEADER;
      TranslateCoords(header,&x,&y,&height,&width);
      XtVaSetValues(popshellHeader,XtNx,x-4,XtNy,y+height,NULL);
   }

   else if (button_widget == style)
   {
      menu = MENU_STYLE;
      TranslateCoords(style,&x,&y,&height,&width);
      XtVaSetValues(popshellStyle,XtNx,x-4,XtNy,y+height,NULL);
   }

   else if (button_widget == list)
   {
      menu = MENU_LIST;
      TranslateCoords(list,&x,&y,&height,&width);
      XtVaSetValues(popshellList,XtNx,x-4,XtNy,y+height,NULL);
   }

   else if (button_widget == accent)
   {
      menu = MENU_ACCENT;
      TranslateCoords(accent,&x,&y,&height,&width);
      XtVaSetValues(popshellAccent,XtNx,x-4,XtNy,y+height,NULL);
   }

   else if (button_widget == spChar)
   {
      menu = MENU_SPCHAR;
      TranslateCoords(spChar,&x,&y,&height,&width);
      XtVaSetValues(popshellSpChar,XtNx,x-4,XtNy,y+height,NULL);
   }
   else if (button_widget == help)
   {
      TranslateCoords(help,&x,&y,&height,&width);
      XtVaSetValues(popshellHelp,XtNx,x-4,XtNy,y+height,NULL);
   }
   else if (button_widget == display)
   {  
      TranslateCoords(display,&x,&y,&height,&width);
      XtVaSetValues(popshellDisplay,XtNx,x-4,XtNy,y+height,NULL);
   }
}


/* show the number of the chosen menupane (it is a callback function) */

void PaneChosen(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
   pane_number = (int)client_data;
}


/* show the number of the chosen menupane (it is a callback function) */

void Pane(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
   pane_choice = (int)client_data;
}



/* Place and pop up the submenu if the pointer leaves the main menu pane through
   its right side */

/*ARGUSED*/
void CheckRightAndPopupSubmenu(w,event,params,num_params)
Widget w;
XEvent *event;
String *params;
Cardinal *num_params;
{
   Widget wid; 
   Dimension height, width;
   XLeaveWindowEvent *leave_event = (XLeaveWindowEvent *)event;
   wid = (Widget)w;


   XtVaGetValues(w,XtNheight,&height,XtNwidth,&width,NULL);

   if ((leave_event->x > (int)width) && (leave_event->x > 0) && (leave_event->y > 0)
	 && (leave_event->y < (int)height))
   {
   /* move submenu shell to start just right of pane, using an arbitrary offset
      to place pointer in first item */
      
      if (wid == menupaneStyle[4])
      {
         XtVaSetValues(subshellLogicalStyle,XtNx,leave_event->x_root,
                    XtNy,leave_event->y_root-12,NULL);

         XtPopup(subshellLogicalStyle,XtGrabNonexclusive);
      }

      else if (wid == menupaneAccent[4])
      {
         XtVaSetValues(subshellOther,XtNx,leave_event->x_root,
                    XtNy,leave_event->y_root-12,NULL);

         XtPopup(subshellOther,XtGrabNonexclusive);
      }
   }
}


/* pop down submenu Other if the pointer leaves the submenu */

/*ARGUSED*/
void PopdownSubmenuOther(w,event,params,num_params)
Widget w;
XEvent *event;
String *params;
Cardinal *num_params;
{  
   XtPopdown(subshellOther);
   menu = MENU_ACCENT;
}



/* pop down submenu LogicalStyle if the pointer leaves the submenu */

/*ARGUSED*/
void PopdownSubmenuLogicalStyle(w,event,params,num_params)
Widget w;
XEvent *event;
String *params;
Cardinal *num_params;
{  
   XtPopdown(subshellLogicalStyle);
   menu = MENU_STYLE;
}


/* add the marks at the beginning and at the end of a selection;
   if there is no selection pops up a warning window */

void WriteMark(str1,str2)
String str1;
String str2;
{
   XawTextPosition start_pos,end_pos;

   XawTextGetSelectionPos(textwindow,&start_pos,&end_pos);

   if (start_pos != end_pos)
   {
      XeditPrintf(str1,textwindow,start_pos);
      XeditPrintf(str2,textwindow,end_pos+strlen(str1));
    }

   else  /* popup a warning if there is not selected text */
      PopupWarning();
}



/* pop up the warning window */

void PopupWarning()
{
   Position x,y;
   Dimension width,height;

   /* first popdown the menu which was activated */

   switch(menu)
   {
      case MENU_HEADER:
         XtPopdown(popshellHeader);
         break;
      case MENU_ANCHOR:
         XtPopdown(popshellAnchor);
         break;
      case MENU_STYLE:
         XtPopdown(subshellLogicalStyle);
         XtPopdown(popshellStyle);
         break;
      case MENU_LIST:
         XtPopdown(popshellList);
         break;
      case MENU_MARK:
         XtPopdown(popshellMark);
         break;
      case MENU_ACCENT:
         XtPopdown(subshellOther);
         XtPopdown(popshellAccent);
         break;
    }
       
    XtVaGetValues(top,XtNwidth,&width,XtNheight,&height,NULL);
    XtTranslateCoords(top,(Position)width/3,(Position)height/3,&x,&y);
    XtVaSetValues(pshellWarning,XtNx,x,XtNy,y,NULL);


    /* make all others buttons insensitive */

    XtSetSensitive(file_wid,FALSE);
    XtSetSensitive(cut,FALSE);
    XtSetSensitive(imgsrc,FALSE);
    XtSetSensitive(route,FALSE);
    XtSetSensitive(header,FALSE);
    XtSetSensitive(style,FALSE);
    XtSetSensitive(list,FALSE);
    XtSetSensitive(mark,FALSE);
    XtSetSensitive(accent,FALSE);
    XtSetSensitive(spChar,FALSE);
    XtSetSensitive(checkup,FALSE);
    XtSetSensitive(help,FALSE);
    XtSetSensitive(vers,FALSE);

    
    /* pop up the warning window */
    
    XtPopup(pshellWarning,XtGrabExclusive);
}


/* write the HTML markup */

void DoMark(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
   String str,str1,str2;
   XawTextPosition pos;
    
   switch(menu)
   {
      case MENU_HEADER:  /* menu Header */
	 switch (pane_number)
	 {
	    case 0:
	       str1 = "<H1>";
	       str2 = "</H1>";
	       break;
	    case 1:
	       str1 = "<H2>";
	       str2 = "</H2>";
	       break;
	    case 2:
	       str1 = "<H3>";
	       str2 = "</H3>";
	       break;
            case 3:
	       str1 = "<H4>";
	       str2 = "</H4>";
	       break;
	    case 4:
	       str1 = "<H5>";
	       str2 = "</H5>";
	       break;
	    case 5:
	       str1 = "<H6>";
	       str2 = "</H6>";
	       break;
	 }
	 WriteMark(str1,str2);
	 break;
      case MENU_STYLE:  /* menu Style */
	 switch(pane_number)
	 {
	    case 0:
	       str1 = "<I>";
	       str2 = "</I>";
	       break;
	    case 1:
	       str1 = "<B>";
	       str2 = "</B>";
	       break;
	    case 2:
	       str1 = "<TT>";
	       str2 = "</TT>";
	       break;
	    case 3:
	       str1 = "<ADDRESS>";
	       str2 = "</ADDRESS>";
	       break;
	    case 4:
	       str1 = "<EM>";
	       str2 = "</EM>";
	       break;
	    case 5:
	       str1 = "<CITE>";
	       str2 = "</CITE>";
	       break;
	    case 6:
	       str1 = "<VAR>";
	       str2 = "</VAR>";
	       break;
	    case 7:
	       str1 = "<STRONG>";
	       str2 = "</STRONG>";
	       break;
	    case 8:
	       str1 = "<CODE>";
	       str2 = "</CODE>";
	       break;
	    case 9:
	       str1 = "<SAMP>";
	       str2 = "</SAMP>";
	       break;
	    case 10:
	       str1 = "<KBD>";
	       str2 = "</KBD>";
	       break;
	    case 11:
	       str1 = "<DFN>";
	       str2 = "</DFN>";
	       break;
	 }
	 WriteMark(str1,str2);
	 break;
      case MENU_LIST:  /* menu List */
	 switch(pane_number)
	 {
	    case 0:
	       str1 = "<LI>";
	       pos = XawTextGetInsertionPoint(textwindow);
	       XeditPrintf(str1,textwindow,pos);
	       break;
	    case 1:
	       str1 = "<UL>";
	       str2 = "</UL>";
	       WriteMark(str1,str2);
	       break;
	    case 2:
	       str1 = "<OL>";
	       str2 = "</OL>";
	       WriteMark(str1,str2);
	       break;
	    case 3:
	       str1 = "<DIR>";
	       str2 = "</DIR>";
	       WriteMark(str1,str2);
	       break;
	    case 4:
	       str1 = "<MENU>";
	       str2 = "</MENU>";
	       WriteMark(str1,str2);
	       break;
	    case 5:
	       str1 = "<DT>";
	       pos = XawTextGetInsertionPoint(textwindow);
	       XeditPrintf(str1,textwindow,pos);
	       break;
	    case 6:
	       str1 = "<DD>";
	       pos = XawTextGetInsertionPoint(textwindow);
	       XeditPrintf(str1,textwindow,pos);
	       break;
	    case 7:
	       str1 = "<DL>";
	       str2 = "</DL>";
	       WriteMark(str1,str2);
	       break;
	 }
	 break;
      case MENU_MARK:  /* menu Mark */
         switch(pane_number)
         {
            case 0:
	       str1 = "<P>";
	       pos = XawTextGetInsertionPoint(textwindow);
	       XeditPrintf(str1,textwindow,pos);
	       break;
	    case 1:
	       str1 = "<TITLE>";
	       str2 = "</TITLE>";
               WriteMark(str1,str2);
	       break;
	    case 2:
	       str1 = "<HTML>";
	       str2 = "</HTML>";
               WriteMark(str1,str2);
	       break;
	    case 3:
	       str1 = "<HEAD>";
	       str2 = "</HEAD>";
               WriteMark(str1,str2);
	       break;
	    case 4:
	       str1 = "<BODY>";
	       str2 = "</BODY>";
               WriteMark(str1,str2);
	       break;
	    case 5:
	       str1 = "<PRE>";
	       str2 = "</PRE>";
               WriteMark(str1,str2);
	       break;
	    case 6:
	       str1 = "<XMP>";
	       str2 = "</XMP>";
               WriteMark(str1,str2);
	       break;
	    case 7:
	       str1 = "<BLOCKQUOTE>";
	       str2 = "</BLOCKQUOTE>";
               WriteMark(str1,str2);
	       break;
	    case 8:
	       str1 = "<!-- ";
	       str2 = " -->";
               WriteMark(str1,str2);
	       break;
            case 9:
	       str1 = "<PLAINTEXT>";
	       pos = XawTextGetInsertionPoint(textwindow);
	       XeditPrintf(str1,textwindow,pos);
	       break;
         }
         break;
      case MENU_SPCHAR:
	 switch(pane_number)
	 {
	    case 0:
	       str1 = "&lt;";
	       break;
	    case 1:
	       str1 = "&gt;";
	       break;
	    case 2:
	       str1 = "&amp;";
	       break;
	    case 3:
	       str1 = "&quot;";
	       break;
	 }
	 pos = XawTextGetInsertionPoint(textwindow);
	 XeditPrintf(str1,textwindow,pos);
	 break;
      case MENU_ACCENT:
	 str1 = "&";
	 switch(pane_number)
	 {
	    case 0:
	       str2 = "acute;";
	       break;
	    case 1:
	       str2 = "circ;";
	       break;
	    case 2:
	       str2 = "grave;";
	       break;
	    case 3:
	       str2 = "cedil;";
	       break;
	    case 4:
	       str2 = "uml;";
	       break;
	    case 5:
	       str2 = "tilde;";
	       break;
	    case 6:
	       str2 = "ring;";
	       break;
	    case 7:
	       str2 = "slash;";
	       break;
	    case 8:
	       str2 = "lig;";
	       break;
	 }
	 WriteMark(str1,str2);
	 break; 
   }
}


/* show the formatted version of the edited file using xmosaic */

void DoCheckup()
{
   int pid, id;

   id = getpid();

   sprintf(test_file,"/tmp/a%d.html",id);

   XawAsciiSaveAsFile(XawTextGetSource(textwindow),test_file);

   ExecXmosaic(test_file);
}


/* Popup the help windows */

void DoHelp()
{
   if (pane_number == 0)
      ExecXmosaic(app_resources.helpGeneralPath);

   else if (pane_number == 1)
      ExecXmosaic(app_resources.helpHTMLPath);
}



/* delete current selection */

void DoCut()
{
   XawTextPosition start_pos,end_pos;
   XawTextBlock text;
   char *str;

   XawTextGetSelectionPos(textwindow,&start_pos,&end_pos);

   str = "";
   text.length = strlen(str);
   text.ptr = str;
   text.firstPos = 0;
   text.format = FMT8BIT;
   
   XawTextReplace(textwindow,start_pos,end_pos,&text);
   XawTextSetInsertionPoint(textwindow,start_pos);
} 
      


/* popup the Version Window */

void ShowVers(w,client_data,call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
   WidgetDone *client;
   Position x,y;
   Dimension width,height;
   
   client = (WidgetDone *)client_data;
   
   XtVaGetValues(client->wid,XtNwidth,&width,XtNheight,&height,NULL);

   XtTranslateCoords(client->wid,(Position)width/2,(Position)height/2,&x,&y);

   switch(client->i)
   {
      case 1:
         XtVaSetValues(pshellVersion,XtNx,x,XtNy,y,NULL);
         XtSetSensitive(vers,FALSE);
         XtPopup(pshellVersion,XtGrabExclusive);
	 break;
   }
}


/* quit a window (version or warning) */

void QuitButton(w,client_data,call_data)
{  
   Widget wid;
   Widget button_widget;

   button_widget = (Widget)w;
 

   /* pop down a window ( version or warning) */

   wid = (Widget)client_data;
   XtPopdown(wid);


   /* make sensitive the button Vers if the quited window is version */

   if(button_widget == version)
      XtSetSensitive(vers,TRUE);

   
   /* if the window to quit is warning make sensitives all other buttons */

   else if (button_widget == warning)
   {
       XtSetSensitive(file_wid,TRUE);
       XtSetSensitive(cut,TRUE);
       XtSetSensitive(imgsrc,TRUE);
       XtSetSensitive(route,TRUE);
       XtSetSensitive(header,TRUE);
       XtSetSensitive(style,TRUE);
       XtSetSensitive(list,TRUE);
       XtSetSensitive(mark,TRUE);
       XtSetSensitive(accent,TRUE);
       XtSetSensitive(spChar,TRUE);
       XtSetSensitive(checkup,TRUE);
       XtSetSensitive(help,TRUE);
       XtSetSensitive(vers,TRUE);
   }
}


/* display the editing file in HTML or ISO_LATIN form */

void DisplayFile()
{
   int pid,id;
   char *file1, *file2 ;

   file1 = (char *)malloc(30);

   id = getpid();

   sprintf(file1,"/tmp/a1%d",id);

   /* save the editing file in a temporary file */

   XawAsciiSaveAsFile(XawTextGetSource(textwindow),file1);
   
   /* transform the temporary file in HTML if pane 0 of the menu Display was activated or
      in ISO_LATIN form if pane 1 of the menu was activated */

   file2 = Transform(file1);
   
   /* load the transformed file in the editing window */

   XtVaSetValues(textwindow,XtNstring,file2,NULL); 
   unlink(file1);
   unlink(file2);  
   free(file1);
   free(file2);
}



/* write in the message label information on all menus and command buttons */

/*ARGUSED*/
void WriteMessage(w,event,params,num_params)
Widget w;
XEvent *event;
String *params;
Cardinal *num_params;

{
   String label;
   Widget button_widget;

   button_widget = (Widget)w;

   if (button_widget == file_wid)
      label = "Activate pulldown menu of File operations";

   else if (button_widget == cut)
      label = "Delete current selection; use also the Delete key. Use Backspace key for deleting one character.";

   else if (button_widget == route)
      label = "Activate pulldown menu of Anchor operations; use selections";

   else if (button_widget == imgsrc)
      label = "Activate pulldown menu of Image source operations; displays images\
 inside documents";

   else if (button_widget == header)
      label = "Activate pulldown menu of Header operations; use selections";

   else if (button_widget == style)
      label = "Activate pulldown menu of Style operations; use selections";

   else if (button_widget == list)
      label = "Activate pulldown menu of List operations";

   else if (button_widget == spChar)
      label = "Activate pulldown menu of Special Characters  operations";

   else if (button_widget == mark)
      label = "Activate pulldown menu of Markup  operations";

   else if (button_widget == accent)
      label = "Activate pulldown menu of Accent  operations; write the text and\
 then use selections";

   else if (button_widget == checkup)
      label = "Pop up the Check Up Window";

   else if (button_widget == help)
      label = "Activate pulldown menu of Help operations";

   else if (button_widget == vers)
      label = "Pop up the Version Window";

   else if (button_widget == version)
      label = "Click inside or type q to quit the version window";

   else if (button_widget == display)
      label = "Activate pulldown menu of Display File operations";

   else if (button_widget == warning)
      label = "Click inside or type q to quit the warning window";

   else if (button_widget == filenamewindow)
      label = "Show the file name";

   /* dialog boxes */
   else if ((button_widget == dialogAnchor)||(button_widget == dialogFtp)||
       (button_widget == dialogLocal)||(button_widget == dialogNews)||
       (button_widget == dialogGopher)||(button_widget == dialogTelnet))
      label = "The anchor name is optional.";
   else if (button_widget == nameRel)
      label = "Move to a particular section within the current document.";


   /* menu anchor */ 
   else if (button_widget == menupaneAnchor[0])
      label = "HTTP protocol; httpadress = \
http://host[:port][/path][?search][#fragmentid]";
   else if (button_widget == menupaneAnchor[1])
      label = "FTP protocol; fileaddress = ftp://host[/path][#fragmentid]";
   else if (button_widget == menupaneAnchor[2])
      label = "Local; fileaddress = path[#fragmentid]";
   else if (button_widget == menupaneAnchor[3])
      label = "Move to a particular section within the current document.";
   else if (button_widget == menupaneAnchor[4])
      label = "NNTP protocol; newsaddress = newsgroup[#fragmentid]";
   else if (button_widget == menupaneAnchor[5])
      label = "GOPHER protocol; gopheraddress = \
host[:port][/gtype[selector]][/path][#fragmentid]";
   else if (button_widget == menupaneAnchor[6])
      label = "TELNET protocol; telenetaddress = [user@]host";
  

   /* menu header */
   else if (button_widget == menupaneHeader[0])
      label = "Bold, very large font, centered. One or two clear space between this\
 and anything following.";
   else if (button_widget == menupaneHeader[1])
      label = "Bold, large font, flush left against left margin, no indent. One or\
 two clear lines above and below.";
   else if (button_widget == menupaneHeader[2])
      label = "Italic, large font, slightly indented from the left margin. One or\
 two clear lines above and below.";
   else if (button_widget == menupaneHeader[3])
      label = "Bold, normal font, indented more than H3. One clear line above and\
 below.";
   else if (button_widget == menupaneHeader[4])
      label = "Italic, normal font, indented as H4. One clear line above.";
   else if (button_widget == menupaneHeader[5])
      label = "Bold, indented same as normal text, more than H5. One clear line\
 above.";


   /* menu Style */
   else if (button_widget == menupaneStyle[0])
      label = "Puts text in italics.";
   else if (button_widget == menupaneStyle[1])
      label = "Puts text in bold.";
   else if (button_widget == menupaneStyle[2])
      label = "Puts text in a fixed-width font.";
   else if (button_widget == menupaneStyle[3])
      label = "Address information (italic).";
   else if (button_widget == menupaneStyle[4])
      label = "Move the pointer out through the right edge of the pane to see the\
 menu of logical styles.";

   /* menu Logical Style */
   else if (button_widget == menupaneLogicalStyle[0])
      label = "Emphasis, typically italic.";
   else if (button_widget == menupaneLogicalStyle[1])
      label = "Citations of names of manuals, sections, or books (italic).";
   else if (button_widget == menupaneLogicalStyle[2])
      label = "A variable name (italic).";
   else if (button_widget == menupaneLogicalStyle[3])
      label = "Strong emphasis, typically bold.";
   else if (button_widget == menupaneLogicalStyle[4])
      label = "Puts text in a fixed-width font.";
   else if (button_widget == menupaneLogicalStyle[5])
      label = "A sequence of literal characters (fixed).";
   else if (button_widget == menupaneLogicalStyle[6])
      label = "Displays the names of keys on the keyboard (fixed).";
   else if (button_widget == menupaneLogicalStyle[7])
      label = "Displays a definition.";

   /* lists */
   else if (button_widget == menupaneList[0])
      label = "List element.";
   else if (button_widget == menupaneList[1])
      label = "Unnumbered list; use selections.";
   else if (button_widget == menupaneList[2])
      label = "Numbered list; use selections.";
   else if (button_widget == menupaneList[3])
      label = "Short elements list; use selections.";
   else if (button_widget == menupaneList[4])
      label = "Menu list; use selections.";
   else if (button_widget == menupaneList[5])
      label = "Definition title.";
   else if (button_widget == menupaneList[6])
      label = "Definition description.";
   else if (button_widget == menupaneList[7])
      label = "Definition list; use selections.";

   /* markup */
   else if (button_widget == menupaneMark[0])
      label = "Paragraph mark.";
   else if (button_widget == menupaneMark[1])
      label = "Document title; use selections.";
   else if (button_widget == menupaneMark[2])
      label = "HTML document; use selections.";
   else if (button_widget == menupaneMark[3])
      label = "Document head; use selections.";
   else if (button_widget == menupaneMark[4])
      label = "Document body; use selections.";
   else if (button_widget == menupaneMark[5])
      label = "Preformatted text; use selections.";
   else if (button_widget == menupaneMark[6])
      label = "Use selections; the text is not interpreted as HTML.";
   else if (button_widget == menupaneMark[7])
      label = "Extended quotes; use selections.";
   else if (button_widget == menupaneMark[8])
      label = "Comment is ignored by the parser; use selections.";
   else if (button_widget == menupaneMark[9])
      label = "Plaintext mark; what follows is not HTML.";

   /* menu accent */ 
   else if (button_widget == menupaneAccent[0])
      label = "The acute accent is defined for the following letters: A, E, I, O,\
 U, Y, a, e, i, o, u, y.";
   else if (button_widget == menupaneAccent[1])
      label = "The circumflex accent is defined for the following letters: A, E, I,\
 O, U, a, e, i, o, u.";
   else if (button_widget == menupaneAccent[2])
      label = "The grave accent is defined for the following letters: A, E, I,\
 O, U, a, e, i, o, u.";
   else if (button_widget == menupaneAccent[3])
      label = "Cedilla is defined for the following letters: C, c.";
   else if (button_widget == menupaneAccent[4])
      label = "Move the pointer out through the right edge of the pane to see\
 other accents";

   
   /* menu other */
   else if (button_widget == menupaneOther[0])
      label = "The umlaut mark (dieresis) is defined for the following letters: \
A, E, I, O, U, a, e, i, o, u, y.";
   else if (button_widget == menupaneOther[1])
      label = "The tilde mark is defined for the following letters: \
A, N, O, a, n, o.";
   else if (button_widget == menupaneOther[2])
      label = "The ring mark is defined for the following letters: A, a.";
   else if (button_widget == menupaneOther[3])
      label = "The slash is defined for the following letters: O, o.";
   else if (button_widget == menupaneOther[4])
      label = "The ligature (diphthong) is defined for the following groups of\
 letters: AE, ae, sz .";

   /* menu Help */
   else if (button_widget == menupaneHelp[0])
      label = "Pop up the General Help Window";
   else if (button_widget == menupaneHelp[1])
      label = "Pop up the HTML Help Window";
   
   /* menu Display */
   else if (button_widget == menupaneDisplay[0])
      label = "Display the HTML form of the file"; 
   else if (button_widget == menupaneDisplay[1])
      label = "Display the ISO_LATIN form of the file"; 

   XtVaSetValues(menulabel,XtNlabel,label,NULL);
}



/*	Function Name: AddDoubleClickCallback(w)
 *	Description: Adds a callback that will reset the double_click flag
 *                   to FALSE when the text is changed.
 *	Arguments: w - widget to set callback upon.
 *                 state - If true add the callback, else remove it.
 *	Returns: none.
 */

AddDoubleClickCallback(w, state)
Widget w;
Boolean state;
{
  Arg args[1];
  static XtCallbackRec cb[] = { {NULL, NULL}, {NULL, NULL} };
 
  if (state) 
    cb[0].callback = ResetDC;
  else
    cb[0].callback = NULL;

  XtSetArg(args[0], XtNcallback, cb);
  XtSetValues(w, args, ONE);
}
  
/*	Function Name: ResetDC
 *	Description: Resets the double click flag.
 *	Arguments: w - the text widget.
 *                 junk, garbage - *** NOT USED ***
 *	Returns: none.
 */

/* ARGSUSED */
static void
ResetDC(w, junk, garbage)
Widget w;
caddr_t junk, garbage;
{
  double_click = FALSE;

  AddDoubleClickCallback(w, FALSE);
}


/* quit the editor */
void
DoQuit()
{
  XawTextPosition pos;

  pos = XawTextGetInsertionPoint(messwidget);

  if( double_click || !source_changed ) 
  { 
    unlink(test_file);
    free(name_anchor);
    free(nameRel_anchor);
    free(name_img);
    free(img_string);
    exit(0); 
  }
  XeditPrintf("Unsaved changes. Save them, or Quit again.\n",messwidget,pos);
  Feep();
  double_click = TRUE;
  AddDoubleClickCallback(textwindow, TRUE);
}

char *
makeBackupName(buf, filename)
String buf, filename;
{
  sprintf(buf, "%s%s%s", app_resources.backupNamePrefix,
	  filename, app_resources.backupNameSuffix);
  return (buf);
}
  
#if defined(USG) && !defined(CRAY)
int rename (from, to)
    char *from, *to;
{
    (void) unlink (to);
    if (link (from, to) == 0) {
        unlink (from);
        return 0;
    } else {
        return -1;
    }
}
#endif


/* save the edited file */

void
DoSave()
{
  XawTextPosition pos;

  String filename = GetString(filenamewindow);
  char buf[BUFSIZ];
  String chaine;
  pos = XawTextGetInsertionPoint(messwidget);
  if( (filename == NULL) || (strlen(filename) == 0) ){
    XeditPrintf("Save:  no filename specified -- nothing saved\n",messwidget,pos);
    Feep();
    return;
  }
  
  if (app_resources.enableBackups) {
    char backup_file[BUFSIZ];
    makeBackupName(backup_file, filename);

    if (rename(filename, backup_file) != 0) {
      sprintf(buf, "error backing up file:  %s\n",  backup_file); 
      pos = XawTextGetInsertionPoint(messwidget);
      XeditPrintf(buf,messwidget,pos);
    }
  }
  
  switch( MaybeCreateFile(filename)) {
  case NO_READ:
  case READ_OK:
      sprintf(buf, "File %s could not be opened for writing.\n", filename);
      break;
  case WRITE_OK:
      if ( XawAsciiSaveAsFile(XawTextGetSource(textwindow), filename) ) {
	  sprintf(buf, "Saved file:  %s\n", filename);
	  ResetSourceChanged(textwindow);
      }
      else 
	  sprintf(buf, "Error saving file:  %s\n",  filename);
      break;
  default:
      sprintf(buf, "%s %s", "Internal function MaybeCreateFile()",
	      "returned unexpected value.\n");
  }

  pos = XawTextGetInsertionPoint(messwidget);
  XeditPrintf(buf,messwidget,pos);
}


/* load the editing file */

void
DoLoad()
{

    Arg args[5];
    XawTextPosition pos;
    Cardinal num_args = 0;
    String filename = GetString(filenamewindow);
    char buf[BUFSIZ], label_buf[BUFSIZ];

    if ( source_changed && !double_click) {
        pos = XawTextGetInsertionPoint(messwidget);
	XeditPrintf("Unsaved changes. Save them, or press Load again.\n",
		    messwidget,pos);
	Feep();
	double_click = TRUE;
	AddDoubleClickCallback(textwindow, TRUE);
	return;
    }
    double_click = FALSE;
    
    if ( (filename != NULL)  &&  ((int) strlen(filename) > 0) ) {
	Boolean exists;

	switch( CheckFilePermissions(filename, &exists) ) {
	case NO_READ:
	    if (exists)
		sprintf(buf, "File %s, %s", filename,
			"exists, and could not be opened for reading.\n");
	    else
		sprintf(buf, "File %s %s %s",  filename, "does not exist, and",
			"the directory could not be opened for writing.\n");

            pos = XawTextGetInsertionPoint(messwidget);
	    XeditPrintf(buf,messwidget,pos);
	    Feep();
	    return;
	case READ_OK:
	    XtSetArg(args[num_args], XtNeditType, XawtextRead); num_args++;
	    sprintf(label_buf, "%s       READ ONLY", filename);
	    sprintf(buf, "File %s opened READ ONLY.\n", filename);
	    break;
	case WRITE_OK:
	    XtSetArg(args[num_args], XtNeditType, XawtextEdit); num_args++;
	    sprintf(label_buf, "%s       Read - Write", filename);
	    sprintf(buf, "File %s opened read - write.\n", filename);
	    break;
	default:
	    sprintf(buf, "%s %s", "Internal function MaybeCreateFile()",
		    "returned unexpected value.\n");
            pos = XawTextGetInsertionPoint(messwidget);
	    XeditPrintf(buf,messwidget,pos);
	    return;
	}

        pos = XawTextGetInsertionPoint(messwidget);
	XeditPrintf(buf,messwidget,pos);
	
	if (exists) {
	    XtSetArg(args[num_args], XtNstring, filename); num_args++;
	}
	else {
	    XtSetArg(args[num_args], XtNstring, NULL); num_args++;
	}

	XtSetValues( textwindow, args, num_args);
	
	num_args = 0;
	XtSetArg(args[num_args], XtNlabel, label_buf); num_args++;
	XtSetValues( labelwindow, args, num_args);
	ResetSourceChanged(textwindow);
	return;
    }

    pos = XawTextGetInsertionPoint(messwidget);
    XeditPrintf("Load: No file specified.\n",messwidget,pos);
    Feep();
}



/*	Function Name: SourceChanged
 *	Description: A callback routine called when the source has changed.
 *	Arguments: w - the text source that has changed.
 *                 junk, garbage - *** UNUSED ***.
 *	Returns: none.
 */

static void
SourceChanged(w, junk, garbage)
Widget w;
XtPointer junk, garbage;
{
    XtRemoveCallback(w, XtNcallback, SourceChanged, NULL);
    source_changed = TRUE;
}



/*	Function Name: ResetSourceChanged.
 *	Description: Sets the source changed to FALSE, and
 *                   registers a callback to set it to TRUE when
 *                   the source has changed.
 *	Arguments: widget - widget to register the callback on.
 *	Returns: none.
 */

void
ResetSourceChanged(widget)
Widget widget;
{
    XtAddCallback(XawTextGetSource(widget), XtNcallback, SourceChanged, NULL);
    source_changed = FALSE;
}
