/**********************************************************************************/
/*                            create.c                                            */
/*            15.11.93 by Sorina COTISEL (cotisel@imag.fr)                        */
/*      Mediatheque IMAG - BP 53X, 38041 GRENOBLE Cedex - mediatheque@imag.fr     */
/*      http://ftpmedia.imag.fr/anteserveur/imag                                  */
/*                                                                                */
/*                                                                                */    
/*    modified on 1.03.94 by Sorina COTISEL for the second version xhtmledit-1.1  */
/*                                                                                */
/*	-> remove the hypertext widget to click on it. From now on use selections */
/*	   also for the anchor                                                    */
/*   		 -modified functions: makeMenuAnchor(),makeDialogAnchor(),        */
/*		                      makeDialogBox(),makeDialogAnchorNameRel()   */
/*      -> add the warning window to use selections:                              */
/*		 -modified functions: makeButtonVers(), makeVersion()             */
/*	         -added functions: makeButton(), makeWarning()                    */
/*                                                                                */
/*   modified on 15.03.94 by Sorina COTISEL for the third version xhtmledit-1.2   */
/*     -> add the menu Display file in HTML or ISO_LATIN form                     */
/*               -added function: makeMenuDisplay()                               */
/*                                                                                */
/*   corrected errors on 11.04.94 for the version xhtmledit-1.2a                  */
/**********************************************************************************/



#include "xhtmledit.h"


Widget textwindow, messwidget, labelwindow, filenamewindow,popshellAnchor,pshellAnchor;
Widget route, menupaneAnchor[N_ANCHOR],pshellLocal,pshellNameAnchor,pshellNameRelativ,pshellNews;
Widget mark,menupaneMark[N_MARK],popshellMark;
Widget file_wid,menupaneFile[N_FILE],popshellFile;
Widget pshellGopher,pshellTelnet;
Widget pshellFtp,imgsrc;
Widget popshellImg,pshellImg,menupaneImg[N_IMG];
Widget popshellDisplay,display,menupaneDisplay[N_DISPLAY];
Widget popshellHeader,menupaneHeader[N_HEADER],header;
Widget popshellStyle,menupaneStyle[N_STYLE],style;
Widget popshellList,menupaneList[N_LIST],list;
Widget popshellAccent,menupaneAccent[N_ACCENT],accent;
Widget popshellSpChar,menupaneSpChar[N_SPCHAR],spChar;
Widget subshellOther,menupaneOther[N_OTHER];
Widget subshellLogicalStyle,menupaneLogicalStyle[N_LSTYLE];
Widget pshellVersion,vers,menulabel,cut,checkup,version;
Widget popshellHelp,menupaneHelp[N_HELP],help;
Widget dialogAnchor,dialogFtp,dialogLocal,dialogNews,dialogGopher,dialogTelnet,dialogImg;
Widget nameAnchor,nameRel;
Widget pshellWarning,warning;

extern char *tab[255];

/* create all widgets */

void
makeButtonsAndBoxes(parent, filename)
Widget parent;
char * filename;
{
  Widget outer, b_row;
  Arg arglist[10];
  Cardinal num_args;

  outer = XtCreateManagedWidget( "paned", panedWidgetClass, parent,
				NULL, ZERO);
 

  /* create a message label */

  menulabel = XtCreateManagedWidget("menulabel",labelWidgetClass,outer,NULL,ZERO);
  XtVaSetValues(menulabel,XtNlabel,"xhtmledit 1.0 - HTML text editor",NULL);


  /* create the commands and menus row */

  b_row= XtCreateManagedWidget("buttons", panedWidgetClass, outer, NULL, ZERO);
  
  {
    makeMenuFile(b_row,parent);
    cut = MakeCommandButton(b_row,"cut",DoCut);

    makeMenuAnchor(b_row,parent);
    makeDialogAnchor(parent);
    makeDialogAnchorNameRel(parent);

    makeMenuImg(b_row,parent);
    makeDialogImg(parent);
 
    /* create the menu header */
    makeMenuAndCallbacks(b_row,parent,&header,"header",&popshellHeader,
      "popshellHeader","menuboxHeader","menupaneHeader",menupaneHeader,N_HEADER);

    /* create the menu style */
    makeMenuAndCallbacks(b_row,parent,&style,"style",&popshellStyle,
      "popshellStyle","menuboxStyle","menupaneStyle",menupaneStyle,N_STYLE);

    /* create the menu list */
    makeMenuAndCallbacks(b_row,parent,&list,"list",&popshellList,
      "popshellList","menuboxList","menupaneList",menupaneList,N_LIST);
    

    /* create the menu markup */
    makeMenuAndCallbacks(b_row,parent,&mark,"mark",&popshellMark,
      "popshellMark","menuboxMark","menupaneMark",menupaneMark,N_MARK);
    
    /* create the menu Special Characters */
    makeMenuAndCallbacks(b_row,parent,&spChar,"spChar",&popshellSpChar,
      "popshellSpChar","menuboxSpChar","menupaneSpChar",menupaneSpChar,N_SPCHAR);
    
    /* create the menu accent */
    makeMenuAndCallbacks(b_row,parent,&accent,"accent",&popshellAccent,
      "popshellAccent","menuboxAccent","menupaneAccent",menupaneAccent,N_ACCENT);

    makeSubMenuOther(parent);

    makeSubMenuLogicalStyle(parent);
    
    /* make command button checkup */
    checkup = MakeCommandButton(b_row, "checkup",DoCheckup);

    makeMenuHelp(b_row,parent);

    makeVersion(parent);

    makeWarning(parent);

    vers = makeButtonVers(b_row,"vers");

    makeMenuDisplay(b_row,parent);

    filenamewindow = MakeStringBox(b_row, "filename", filename); 
  }


  XtCreateManagedWidget("bc_label", labelWidgetClass, outer, NULL, ZERO);

  num_args = 0;
  XtSetArg(arglist[num_args], XtNeditType, XawtextEdit); num_args++;
  messwidget = XtCreateManagedWidget("messageWindow", asciiTextWidgetClass,
				      outer, arglist, num_args);

  num_args = 0;
  if (filename != NULL) 
    XtSetArg(arglist[num_args], XtNlabel, filename); num_args++;

  labelwindow = XtCreateManagedWidget("labelWindow",labelWidgetClass, 
				      outer, arglist, num_args);

  num_args = 0;
  XtSetArg(arglist[num_args], XtNtype, XawAsciiFile); num_args++;
  XtSetArg(arglist[num_args], XtNeditType, XawtextEdit); num_args++;
  textwindow =  XtCreateManagedWidget("editWindow", asciiTextWidgetClass, 
	outer, arglist, num_args);
  
  /* install labels, translations and accelerators */

  makeTranslations();
  makeDialogLabels();

 /* XtInstallAccelerators(textwindow,cut); */
  XtInstallAccelerators(version,version);
  XtInstallAccelerators(warning,warning);

  /* initialize the characther table */
   InitTabChar();



  if (filename != NULL)
      DoLoad();
  else
      ResetSourceChanged(textwindow);
}


/* create the menu ( the box and the panes of the menu)  */

Widget makeMenu(shell_name,parent_shell,button_head,box_name,nb_panes,pane_name, menu_tab)
String shell_name;
Widget parent_shell;
Widget button_head;
String box_name;
int nb_panes;
String pane_name;
Widget *menu_tab;

{
    Widget pop,menubox,menupane[20];
    Dimension width;
    int i;
    String buffer;
    
    buffer = (char *)malloc(50);
    /* create popup for menu */
    pop = XtCreatePopupShell(shell_name,transientShellWidgetClass,
				   parent_shell,NULL,0);
     
    
    /* create the box for menu */
    menubox = XtCreateManagedWidget(box_name,boxWidgetClass,pop,NULL,0);

    XtVaSetValues(menubox,XtNhSpace,0,XtNvSpace,0,NULL);

    XtVaGetValues(button_head,XtNwidth,&width,NULL);
    
    /* create the panes of the menu */
    for (i = 0; i < nb_panes; i++)
    {
      sprintf(buffer,"%s%d",pane_name,i);
      *menu_tab = XtCreateManagedWidget(buffer,commandWidgetClass,menubox,
					  NULL,0);
      XtVaSetValues(*menu_tab,XtNwidth,width,NULL);
      menu_tab++;
    }
    free(buffer);
    return(pop);
}


/* create a dialog box including the Done and Cancel buttons; add also the callback
   for the Cancel button */

Widget makeDialog(dialog_name,dialog_widget,shell_name,shell_parent,
	   done_widget,cancel_number)
String dialog_name;
Widget *dialog_widget;
String shell_name;
Widget shell_parent;
Widget *done_widget;
int cancel_number;
{
    Widget popsh;
    Widget cancel_widget;
    
    /* create the popshell and the dialog Widget */

    popsh = XtVaCreatePopupShell(shell_name,transientShellWidgetClass,
				 shell_parent,NULL);
    *dialog_widget = XtVaCreateManagedWidget(dialog_name,dialogWidgetClass,
		      popsh,NULL);

    /* create the Done and Cancel buttons */

    *done_widget = XtVaCreateManagedWidget("dialogDone",commandWidgetClass,
					  *dialog_widget,NULL);
    cancel_widget = XtVaCreateManagedWidget("dialogCancel",commandWidgetClass,
					   *dialog_widget,NULL); 

    /* add the callback for the Cancel button */

    XtAddCallback(cancel_widget,XtNcallback,DialogCancel,(XtPointer)cancel_number);
    
    return(popsh);

}


/* create the menu  for the anchor */

void makeMenuAnchor(parent1,parent2)
Widget parent1;
Widget parent2;
{
    int i;   

    /* create the command button for menu */

    route = XtCreateManagedWidget("route",commandWidgetClass,parent1,NULL,0);
    
    /* create the menu */

    popshellAnchor = makeMenu("popshellAnchor",parent2,route,"menuboxAnchor",N_ANCHOR,
			      "menupaneAnchor",menupaneAnchor);

    /* add the callbacks for the menu */

    for (i=0;i<N_ANCHOR;i++)
      XtAddCallback(menupaneAnchor[i],XtNcallback,PaneChosen,(XtPointer)i);

    XtAddCallback(menupaneAnchor[0],XtNcallback,PopupDialog,(XtPointer)1); /* dialog for http */
    XtAddCallback(menupaneAnchor[1],XtNcallback,PopupDialog,(XtPointer)9); /* dialog for ftp */
    XtAddCallback(menupaneAnchor[2],XtNcallback,PopupDialog,(XtPointer)2); /* dialog for local */
    XtAddCallback(menupaneAnchor[3],XtNcallback,PopupDialog,(XtPointer)5); /*dialog for nameRel */ 
    XtAddCallback(menupaneAnchor[4],XtNcallback,PopupDialog,(XtPointer)6); /* dialog for news */
    XtAddCallback(menupaneAnchor[5],XtNcallback,PopupDialog,(XtPointer)7); /* dialog for gopher*/
    XtAddCallback(menupaneAnchor[6],XtNcallback,PopupDialog,(XtPointer)8); /* dialog for telnet*/

}
   


/* create the dialog boxes and the menus poped up from the menu Anchor */

void makeDialogAnchor(parent)
Widget parent;
{

   Widget nameDone;
   Widget hypStringDone;
   WidgetDone *client_name;
   int i;

   client_name = (WidgetDone *)malloc(sizeof(WidgetDone));

   /* create the dialog box for http et ftp */
   makeDialogBox("dialogAnchor",&dialogAnchor,"pshellAnchor",&pshellAnchor,parent,/*-- &hypertext,*/1);


    /* create the dialog box for ftp */
   makeDialogBox("dialogFtp",&dialogFtp,"pshellFtp",&pshellFtp,parent,9);

    /* create the dialog box for local */
   makeDialogBox("dialogLocal",&dialogLocal,"pshellLocal",&pshellLocal,parent,2);

   /* create the dialog box for news */
   makeDialogBox("dialogNews",&dialogNews,"pshellNews",&pshellNews,parent,6);
		
   /* create the dialog box for gopher */
   makeDialogBox("dialogGopher",&dialogGopher,"pshellGopher",&pshellGopher,
		  parent,7);

   /* create the dialog box for telnet */
   makeDialogBox("dialogTelnet",&dialogTelnet,"pshellTelnet",&pshellTelnet,
		  parent,8);


    /* create the dialog box for name anchor */

    pshellNameAnchor = makeDialog("nameAnchor",&nameAnchor,"pshellNameAnchor",parent,
		 &nameDone,3);


    /* add the callbacks for name */

    client_name->wid = nameAnchor;
    client_name->i = 1;
    XtAddCallback(nameDone,XtNcallback,Done,(XtPointer)client_name);
    
}


/* create a dialog box including all buttons: Done,Cancel,Name anchor,Hyperlink */

void
makeDialogBox(dialog_name,dialog_widget,pshell_name,pshell_widget,parent,cancel_number)
String dialog_name;
Widget *dialog_widget;
String pshell_name;
Widget *pshell_widget;
Widget parent;
int cancel_number;
{
   Widget dialogDone,dialogName;

   /* create the dialog box */

   *pshell_widget = makeDialog(dialog_name,dialog_widget,pshell_name,parent,
		   &dialogDone,cancel_number);
   /* create the name widget of the box */

   dialogName = XtVaCreateManagedWidget("dialogName",commandWidgetClass,
		*dialog_widget,NULL);

   /* add the callbacks */

   XtAddCallback(dialogDone,XtNcallback,DialogDone,*dialog_widget);
   XtAddCallback(dialogName,XtNcallback,PopupDialog,(XtPointer)3);

}



/* create the dialog box for moving to a particular section within the current
   document (relative anchor) */

void makeDialogAnchorNameRel(parent)
Widget parent;
{
   Widget nameRelDone;
   Widget nameRelCancel; 
   WidgetDone *client_nameRel;

   client_nameRel = (WidgetDone *)malloc(sizeof(WidgetDone));

    /* create the dialog box for relative name of the anchor */

    pshellNameRelativ =  makeDialog("nameRel",&nameRel,"pshellNameRel",parent,
                    &nameRelDone,5);
    

    /* add the callbacks */

    client_nameRel->wid = nameRel;
    client_nameRel->i = 3;
    XtAddCallback(nameRelDone,XtNcallback,Done,(XtPointer)client_nameRel);
}



/* make the dialog box poped up from the menu Image Source */

void makeDialogImg(parent)
Widget parent;
{
   Widget dialogImgDone;
   WidgetDone *client_img;

   client_img = (WidgetDone *)malloc(sizeof(WidgetDone));

   /* create the dialog box for Imgsrc */

   pshellImg = makeDialog("dialogImg",&dialogImg,"pshellImg",parent,
			  &dialogImgDone,10);
   /* add the callbacks */

   client_img->wid = dialogImg;
   client_img->i = 4;
   XtAddCallback(dialogImgDone,XtNcallback,Done,(XtPointer)client_img);
}
	

/* create the menu Image Source */

void makeMenuImg(parent1,parent2)
Widget parent1;
Widget parent2;
{
   int i;

   /* create the command button for the menu */
   imgsrc = MakeCommandButton(parent1,"imgsrc",NULL);

   /* create the menu */
   popshellImg = makeMenu("popshellImg",parent2,imgsrc,"menuboxImg",N_IMG,"menupaneImg",
		 menupaneImg);
   
   /* add the callbacks */
    for (i = 0;i<N_IMG;i++)
    {
       XtAddCallback(menupaneImg[i],XtNcallback,PopupDialog,(XtPointer)10);
       XtAddCallback(menupaneImg[i],XtNcallback,Pane,(XtPointer)i);
    }
}
   


/* create the menu File */

void makeMenuFile(parent1,parent2)
Widget parent1;
Widget parent2;
{
   int i;


   /*create the command button for the menu */
   file_wid = XtCreateManagedWidget("file",commandWidgetClass,parent1,NULL,0);

   /* create the menu */
   popshellFile = makeMenu("popshellFile",parent2,file_wid,
		     "menuboxFile",N_FILE,"menupaneFile",menupaneFile);

   /* add the callbacks */
   for (i = 0; i<N_FILE;i++)
   {
      XtAddCallback(menupaneFile[i],XtNcallback,PaneChosen,(XtPointer)i);
   }
   XtAddCallback(menupaneFile[0],XtNcallback,DoSave,(XtPointer)0);
   XtAddCallback(menupaneFile[1],XtNcallback,DoLoad,(XtPointer)0);
   XtAddCallback(menupaneFile[2],XtNcallback,DoQuit,(XtPointer)0);
   
}


/* create the menu Help */

void makeMenuHelp(parent1,parent2)
Widget parent1;
Widget parent2;
{
   int i;

   /*create the command button for the menu */
   help = XtCreateManagedWidget("help",commandWidgetClass,parent1,NULL,0);

   /* create the menu */
   popshellHelp = makeMenu("popshellHelp",parent2,help,
		     "menuboxHelp",N_HELP,"menupaneHelp",menupaneHelp);

   /* add the callbacks */
   for (i = 0; i<N_HELP;i++)
   {
      XtAddCallback(menupaneHelp[i],XtNcallback,PaneChosen,(XtPointer)i);
      XtAddCallback(menupaneHelp[i],XtNcallback,DoHelp,(XtPointer)0);
   }
}



/* make the button,the associated menu and add the callbacks to menupanes */

void makeMenuAndCallbacks(parent1,parent2,button_widget,button_name,
  popshell_widget,popshell_name,menubox_name,menupane_name,menupane_widget,nb_panes)
Widget parent1;
Widget parent2;
Widget *button_widget;
String button_name;
Widget *popshell_widget;
String popshell_name;
String menubox_name;
String menupane_name;
Widget *menupane_widget;
int nb_panes;
{
   int i;


   /*create the command button for the menu */
   *button_widget = XtCreateManagedWidget(button_name,commandWidgetClass,parent1,
		    NULL,0);

   /* create the menu */
   *popshell_widget = makeMenu(popshell_name,parent2,*button_widget,
		     menubox_name,nb_panes,menupane_name,menupane_widget);

   /* add the callbacks */
   for (i = 0; i<nb_panes;i++)
   {
      XtAddCallback(*menupane_widget,XtNcallback,PaneChosen,(XtPointer)i);
      XtAddCallback(*menupane_widget,XtNcallback,DoMark,(XtPointer)0);
      menupane_widget++;
   }
}



/* make the submenu Other poped up from the menu Accent */

void makeSubMenuOther(parent)
Widget parent;
{
   int i;

   /* create the menu */

   subshellOther = makeMenu("subshellOther",parent,accent,
		     "subboxOther",N_OTHER,"menupaneOther",menupaneOther);
   
   /* add the callbacks */

   for (i = 0; i<N_OTHER;i++)
   {
      XtAddCallback(menupaneOther[i],XtNcallback,PaneChosen,(XtPointer)(i+4));
      XtAddCallback(menupaneOther[i],XtNcallback,DoMark,(XtPointer)0);
   }
}



/* make the submenu Logical Style poped up from the menu Style */

void makeSubMenuLogicalStyle(parent)
Widget parent;
{
   int i;

   subshellLogicalStyle = makeMenu("subshellLogicalStyle",parent,style,
          "subboxLogicalStyle",N_LSTYLE,"menupaneLogicalStyle",menupaneLogicalStyle);

   for (i = 0; i<N_LSTYLE;i++)
   {
      XtAddCallback(menupaneLogicalStyle[i],XtNcallback,PaneChosen,(XtPointer)(i+4));
      XtAddCallback(menupaneLogicalStyle[i],XtNcallback,DoMark,(XtPointer)0);
   }
}



/* make button vers that pops up the Version Window and the associated callback ShowVers */

Widget makeButtonVers(parent,vers_name)
Widget parent;
String vers_name;
{
   Widget vers_widget;
   WidgetDone *client_version;

   client_version = (WidgetDone *)malloc(sizeof(WidgetDone));

   client_version->wid = parent;
   client_version->i = 1;
   
   vers_widget = XtVaCreateManagedWidget(vers_name,commandWidgetClass,parent,NULL);
   XtAddCallback(vers_widget,XtNcallback,ShowVers,(XtPointer)client_version);

   return(vers_widget);
}


/* make the Version Window */

void makeVersion(parent)
Widget parent;
{
   String label_version;

   label_version = "***********************************************************\n    XHTMLEDIT - version 1.2a\n    11.04.1994\n\n    Simple HTML Editor based on the old xedit\n\n    by Sorina COTISEL\
    (cotisel@imag.fr)\n\n    Mediatheque - IMAG (mediatheque@imag.fr)\n\
    BP 53X, 38041 GRENOBLE Cedex, FRANCE\n\n    http://ftpmedia.imag.fr/anteserveur/imag\n\n***********************************************************\n";

   pshellVersion = makeButton(parent,"pshellVersion",&version,"version",label_version);
} 



/* create a button widget with a label_string and a callback to quit it */

Widget makeButton(parent,shell_name,button,button_name,label_string)
Widget parent;
String shell_name;
Widget *button;
String button_name;
String label_string;
{
   Widget shell_widget;

   shell_widget = XtVaCreatePopupShell(shell_name,transientShellWidgetClass,parent,NULL);

   *button = XtVaCreateManagedWidget(button_name,commandWidgetClass,shell_widget,NULL);
   XtAddCallback(*button,XtNcallback,QuitButton,shell_widget);

   XtVaSetValues(*button,XtNlabel,label_string,NULL);
    
   return(shell_widget);
}


/* create the warning window and the associated callback to quit it */

void makeWarning(parent)
Widget parent;
{
   String label_warning;

   label_warning = "============================================\n\n                WARNING !!!  \n          Use selections, please !\n\n Click inside or type q to quit the warning\n============================================";
   
   pshellWarning = makeButton(parent,"pshellWarning",&warning,"warning",label_warning);
}

void makeMenuDisplay(parent1,parent2)
Widget parent1;
Widget parent2;
{
   int i;
   /* create the command button for the menu */
   display = MakeCommandButton(parent1,"display",NULL);

   /* create the menu */
   popshellDisplay = makeMenu("popshellDisplay",parent2,display,"menuboxDisplay",N_DISPLAY,
                     "menupaneDisplay",menupaneDisplay);

   /* add the callbacks */
   for (i = 0;i<N_DISPLAY;i++)
   {
      XtAddCallback(menupaneDisplay[i],XtNcallback,PaneChosen,(XtPointer)i);
      XtAddCallback(menupaneDisplay[i],XtNcallback,DisplayFile,(XtPointer)0); 
   }
}
