/**********************************************************************************/
/*                            resources.c                                         */
/*                15.11.93 by Sorina COTISEL (cotisel@imag.fr)                    */
/*     Mediatheque IMAG - BP 53X, 38041 GRENOBLE Cedex - mediatheque@imag.fr      */
/*     http://ftpmedia.imag.fr/anteserveur/imag                                   */
/*                                                                                */
/*     modified on 1.03.94 by Sorina COTISEL for the second version xhtmledit-1.1 */
/*                                                                                */
/*     modified function makeTranslations() : removed translations of hypertext,  */
/*                                            of menupaneHyp and translation that */
/*                                            poped down the menu Hypertext       */
/*     modified on 15.03.94 by Sorina COTISEL for the third version xhtmledit-1.2 */
/*            - modified function: makeTranslations()                             */
/*                                                                                */
/*     corrected errors on 11.04.94 for the xhtmledit-1.2a version                */
/**********************************************************************************/



#include "xhtmledit.h"

extern Widget route,file_wid,imgsrc,header,style,list,accent,mark,spChar,help,display;
extern Widget checkup,cut,vers,filenamewindow,version,warning;
extern Widget menupaneFile[N_FILE],menupaneAnchor[N_ANCHOR],menupaneImg[N_IMG];
extern Widget menupaneStyle[N_STYLE],menupaneList[N_LIST],menupaneMark[N_MARK];
extern Widget menupaneSpChar[N_SPCHAR],menupaneHelp[N_HELP],menupaneDisplay[N_DISPLAY];
extern Widget menupaneOther[N_OTHER],menupaneLogicalStyle[N_LSTYLE],menupaneHeader[N_HEADER];
extern Widget popshellFile,popshellAnchor,popshellImg,popshellHeader, popshellStyle;
extern Widget popshellList,popshellAccent,popshellMark,popshellSpChar,popshellHelp;
extern Widget subshellOther,subshellLogicalStyle,popshellDisplay,menupaneAccent[N_ACCENT];
extern Widget dialogAnchor,dialogFtp,dialogLocal,dialogNews,dialogGopher,dialogTelnet,dialogImg;
extern Widget nameAnchor,nameRel;


/*  make widgets translations */

void makeTranslations()
{
   int i;

/* translations that pop up menus */

   XtOverrideTranslations(route,XtParseTranslationTable("#override\n\
	<Btn1Down>: set() placeMenu() XtMenuPopup(popshellAnchor)\n\
	<EnterWindow>: set() writeMessage()"));

   XtOverrideTranslations(file_wid,XtParseTranslationTable("#override\n\
	<Btn1Down>: set() placeMenu() XtMenuPopup(popshellFile)\n\
	<EnterWindow>: set() writeMessage()"));
   
   XtOverrideTranslations(imgsrc,XtParseTranslationTable("#override\n\
	<Btn1Down>: set() placeMenu() XtMenuPopup(popshellImg)\n\
	<EnterWindow>: set() writeMessage()"));

   XtOverrideTranslations(header,XtParseTranslationTable("#override\n\
	<Btn1Down>: set() placeMenu() XtMenuPopup(popshellHeader)\n\
	<EnterWindow>: set() writeMessage()"));

   XtOverrideTranslations(style,XtParseTranslationTable("#override\n\
	<Btn1Down>: set() placeMenu() XtMenuPopup(popshellStyle)\n\
	<EnterWindow>: set() writeMessage()"));

   XtOverrideTranslations(list,XtParseTranslationTable("#override\n\
	<Btn1Down>: set() placeMenu() XtMenuPopup(popshellList)\n\
	<EnterWindow>: set() writeMessage()"));

   XtOverrideTranslations(accent,XtParseTranslationTable("#override\n\
	<Btn1Down>: set() placeMenu() XtMenuPopup(popshellAccent)\n\
	<EnterWindow>: set() writeMessage()"));

   XtOverrideTranslations(mark,XtParseTranslationTable("#override\n\
	<Btn1Down>: set() placeMenu() XtMenuPopup(popshellMark)\n\
	<EnterWindow>: set() writeMessage()"));

   XtOverrideTranslations(spChar,XtParseTranslationTable("#override\n\
	<Btn1Down>: set() placeMenu() XtMenuPopup(popshellSpChar)\n\
	<EnterWindow>: set() writeMessage()"));

   XtOverrideTranslations(help,XtParseTranslationTable("#override\n\
	<Btn1Down>: set() placeMenu() XtMenuPopup(popshellHelp)\n\
	<EnterWindow>: set() writeMessage()"));

   XtOverrideTranslations(display,XtParseTranslationTable("#override\n\
	<Btn1Down>: set() placeMenu() XtMenuPopup(popshellDisplay)\n\
	<EnterWindow>: set() writeMessage()"));

/* translations of command buttons */

   XtOverrideTranslations(cut,XtParseTranslationTable("#override\n\
	<EnterWindow>: set() writeMessage()"));

   XtOverrideTranslations(checkup,XtParseTranslationTable("#override\n\
	<EnterWindow>: set() writeMessage()"));

   XtOverrideTranslations(vers,XtParseTranslationTable("#override\n\
	<EnterWindow>: set() writeMessage()"));

   XtOverrideTranslations(filenamewindow,XtParseTranslationTable("#override\n\
	<EnterWindow>: writeMessage()"));

   XtOverrideTranslations(version,XtParseTranslationTable("#override\n\
	<EnterWindow>: writeMessage()"));

   XtOverrideTranslations(warning,XtParseTranslationTable("#override\n\
	<EnterWindow>: writeMessage()"));


/* translations of menupanes */

   /* menupaneFile */
   for (i = 0;i<N_FILE;i++)
   {
      XtOverrideTranslations(menupaneFile[i],XtParseTranslationTable("#override\n\
	<EnterWindow>: set()    \n\
	<LeaveWindow>: unset()  \n\
	<Btn1Up>: notify()  unset()"));
   }

   /* menupaneAnchor */
   for (i = 0;i<N_ANCHOR;i++)
   {
      XtOverrideTranslations(menupaneAnchor[i],XtParseTranslationTable("#override\n\
	<EnterWindow>: set() writeMessage() \n\
	<LeaveWindow>: unset()  \n\
	<Btn1Up>: notify()  unset()"));
   }
   

   /* menupaneImg */
   for (i = 0;i<N_IMG;i++)
   {
      XtOverrideTranslations(menupaneImg[i],XtParseTranslationTable("#override\n\
	<EnterWindow>: set()    \n\
	<LeaveWindow>: unset()  \n\
	<Btn1Up>: notify()  unset()"));
   }
  
   /* menupaneHeader */
   for (i = 0;i<N_HEADER;i++)
   {
      XtOverrideTranslations(menupaneHeader[i],XtParseTranslationTable("#override\n\
	<EnterWindow>: set() writeMessage()   \n\
	<LeaveWindow>: unset()  \n\
	<Btn1Up>: notify()  unset()"));
   }

   /* menupaneStyle */
   for (i = 0;i<N_STYLE;i++)
   {
      XtOverrideTranslations(menupaneStyle[i],XtParseTranslationTable("#override\n\
	<EnterWindow>: set() writeMessage()   \n\
	<LeaveWindow>: unset()  \n\
	<Btn1Up>: notify()  unset()"));
   }

   /* menupaneList */
   for (i = 0;i<N_LIST;i++)
   {
      XtOverrideTranslations(menupaneList[i],XtParseTranslationTable("#override\n\
	<EnterWindow>: set() writeMessage()   \n\
	<LeaveWindow>: unset()  \n\
	<Btn1Up>: notify()  unset()"));
   }

   /* menupaneAccent */
   for (i = 0;i<N_ACCENT;i++)
   {
      XtOverrideTranslations(menupaneAccent[i],XtParseTranslationTable("#override\n\
	<EnterWindow>: set() writeMessage()   \n\
	<LeaveWindow>: unset()  \n\
	<Btn1Up>: notify()  unset()"));
   }

   /* menupaneMark */
   for (i = 0;i<N_MARK;i++)
   {
      XtOverrideTranslations(menupaneMark[i],XtParseTranslationTable("#override\n\
	<EnterWindow>: set() writeMessage()   \n\
	<LeaveWindow>: unset()  \n\
	<Btn1Up>: notify()  unset()"));
   }

   /* menupaneSpChar  */
   for (i = 0;i<N_SPCHAR;i++)
   {
      XtOverrideTranslations(menupaneSpChar[i],XtParseTranslationTable("#override\n\
	<EnterWindow>: set()    \n\
	<LeaveWindow>: unset()  \n\
	<Btn1Up>: notify()  unset()"));
   } 

   /* menupaneHelp */
   for (i = 0;i<N_HELP;i++)
   {
      XtOverrideTranslations(menupaneHelp[i],XtParseTranslationTable("#override\n\
	<EnterWindow>: set()  writeMessage()  \n\
	<LeaveWindow>: unset()  \n\
	<Btn1Up>: notify()  unset()"));
   }

   /* menupaneDisplay */
   for (i = 0;i<N_DISPLAY;i++)
   {
      XtOverrideTranslations(menupaneDisplay[i],XtParseTranslationTable("#override\n\
	<EnterWindow>: set()  writeMessage()  \n\
	<LeaveWindow>: unset()  \n\
	<Btn1Up>: notify()  unset()"));
   }

   /* menupaneOther */
   for (i = 0;i<N_OTHER;i++)
   {
      XtOverrideTranslations(menupaneOther[i],XtParseTranslationTable("#override\n\
	<EnterWindow>: set() writeMessage()   \n\
	<LeaveWindow>: unset()  \n\
	<Btn1Up>: notify()  unset()"));
   }
   
   /* menupaneLogicalStyle */
   for (i = 0;i<N_LSTYLE;i++)
   {
      XtOverrideTranslations(menupaneLogicalStyle[i],XtParseTranslationTable("#override\n\
	<EnterWindow>: set() writeMessage()   \n\
	<LeaveWindow>: unset()  \n\
	<Btn1Up>: notify()  unset()"));
   }

/* translations that pop up submenus */
   
   XtOverrideTranslations(menupaneAccent[4],XtParseTranslationTable("#override\n\
	<LeaveWindow>: unset() checkRightAndPopupSubmenu() \n\
	<EnterWindow>: set() writeMessage()"));

   XtOverrideTranslations(menupaneStyle[4],XtParseTranslationTable("#override\n\
	<LeaveWindow>: unset() checkRightAndPopupSubmenu() \n\
	<EnterWindow>: set() writeMessage()"));


/* translations that pop down menus */

  XtOverrideTranslations(popshellFile,XtParseTranslationTable("\
	<Btn1Up>: XtMenuPopdown(popshellFile)"));

  XtOverrideTranslations(popshellAnchor,XtParseTranslationTable("\
	<Btn1Up>: XtMenuPopdown(popshellAnchor)"));

  XtOverrideTranslations(popshellImg,XtParseTranslationTable("\
	<Btn1Up>: XtMenuPopdown(popshellImg)"));

  XtOverrideTranslations(popshellHeader,XtParseTranslationTable("\
	<Btn1Up>: XtMenuPopdown(popshellHeader)"));

  XtOverrideTranslations(popshellStyle,XtParseTranslationTable("\
	<Btn1Up>:  XtMenuPopdown(subshellLogicalStyle) XtMenuPopdown(popshellStyle)"));

  XtOverrideTranslations(popshellList,XtParseTranslationTable("\
	<Btn1Up>: XtMenuPopdown(popshellList)"));

  XtOverrideTranslations(popshellAccent,XtParseTranslationTable("\
	<Btn1Up>: XtMenuPopdown(subshellOther) XtMenuPopdown(popshellAccent)"));

  XtOverrideTranslations(popshellMark,XtParseTranslationTable("\
	<Btn1Up>: XtMenuPopdown(popshellMark)"));

  XtOverrideTranslations(popshellSpChar,XtParseTranslationTable("\
	<Btn1Up>: XtMenuPopdown(popshellSpChar)"));

  XtOverrideTranslations(popshellHelp,XtParseTranslationTable("\
	<Btn1Up>: XtMenuPopdown(popshellHelp)"));

  XtOverrideTranslations(popshellDisplay,XtParseTranslationTable("\
	<Btn1Up>: XtMenuPopdown(popshellDisplay)"));

/* translations that pop down submenus */

  XtOverrideTranslations(subshellOther,XtParseTranslationTable("\
	<LeaveWindow>: popdownSubmenuOther()"));

  XtOverrideTranslations(subshellLogicalStyle,XtParseTranslationTable("\
	<LeaveWindow>: popdownSubmenuLogicalStyle()"));

/* translations of the dialog boxes */
  XtOverrideTranslations(dialogAnchor,XtParseTranslationTable("#override\n\
	<EnterWindow>: writeMessage()")); 
  XtOverrideTranslations(dialogFtp,XtParseTranslationTable("#override\n\
	<EnterWindow>: writeMessage()")); 
  XtOverrideTranslations(dialogLocal,XtParseTranslationTable("#override\n\
	<EnterWindow>: writeMessage()")); 
  XtOverrideTranslations(dialogNews,XtParseTranslationTable("#override\n\
	<EnterWindow>: writeMessage()")); 
  XtOverrideTranslations(dialogGopher,XtParseTranslationTable("#override\n\
	<EnterWindow>: writeMessage()")); 
  XtOverrideTranslations(dialogTelnet,XtParseTranslationTable("#override\n\
	<EnterWindow>: writeMessage()")); 
  XtOverrideTranslations(nameRel,XtParseTranslationTable("#override\n\
	<EnterWindow>: writeMessage()")); 
}



void makeDialogLabels()
{
   XtVaSetValues(dialogAnchor,XtNlabel,"********** Enter the link : host[:port][/path][?search]\
[#fragmentid] **********",NULL);
   XtVaSetValues(dialogFtp,XtNlabel,"************* Enter the link : host[/path][#fragmentid] *************",NULL);
   XtVaSetValues(dialogLocal,XtNlabel,"************* Enter the link : path[#fragmentid] *************",NULL);
   XtVaSetValues(dialogNews,XtNlabel,"************* Enter the link : newsgroup[#fragmentid] ************",NULL);
   XtVaSetValues(dialogGopher,XtNlabel,"****** Enter the link : host[:port][/gtype[selector]][/path][#fragmentid] ******",NULL);
   XtVaSetValues(dialogTelnet,XtNlabel,"******** Enter the host : [user@]host ********",NULL);
   XtVaSetValues(nameAnchor,XtNlabel,"********* Enter the anchor name : *********",NULL);
   XtVaSetValues(nameRel,XtNlabel,"****** Enter the anchor relative name (fragmentid) : ******",
		 NULL);
/*   XtVaSetValues(hypString,XtNlabel,"********* Enter the text or image source ( [host/]path ) : *********",NULL); */
   XtVaSetValues(dialogImg,XtNlabel,"************ Enter the image source ( [host/]path ) : ************",NULL);

}
