#if (!defined(lint) && !defined(SABER))
static char Xrcsid[] = "$XConsortium: util.c,v 1.14 89/10/07 14:59:43 kit Exp $";
#endif /* lint && SABER */

/*
 *			  COPYRIGHT 1987
 *		   DIGITAL EQUIPMENT CORPORATION
 *		       MAYNARD, MASSACHUSETTS
 *			ALL RIGHTS RESERVED.
 *
 * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
 * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
 * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE FOR
 * ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
 *
 * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT RIGHTS,
 * APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN ADDITION TO THAT
 * SET FORTH ABOVE.
 *
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Digital Equipment Corporation not be 
 * used in advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.
 */




/**********************************************************************************/
/*                            util.c                                              */
/*                      based on the old xedit util.c                             */
/*            modified on 15.11.93 by Sorina COTISEL (cotisel@imag.fr)            */
/*      Mediatheque IMAG - BP 53X, 38041 GRENOBLE Cedex - mediatheque@imag.fr     */
/*      http://ftpmedia.imag.fr/anteserveur/imag
/*                                                                                */
/*                                                                                */
/*    modified on 1.03.94 by Sorina COTISEL for the second version xhtmledit-1.1  */
/*                                                                                */
/*    The function WriteMark() was modified and moved in the commands.c module    */
/*                                                                                */
/**********************************************************************************/



#include <stdio.h>
#include "xhtmledit.h"

#include <X11/Xos.h>		/* for types.h */
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>

extern Widget messwidget;
extern Widget textwindow;


/* write a string in a text widget */

void
XeditPrintf(str,place,pos)
char * str;
Widget place;
XawTextPosition pos;
{
  XawTextBlock text;


  text.length = strlen(str);
  text.ptr = str;
  text.firstPos = 0;
  text.format = FMT8BIT;

  XawTextReplace( place, pos, pos, &text);

  pos += text.length;
  XawTextSetInsertionPoint(place, pos);
}


/* make a command button and add the associated callback function */

Widget
MakeCommandButton(box, name, function)
Widget box;
char *name;
XtCallbackProc function;
{
  Widget w = XtCreateManagedWidget(name, commandWidgetClass, box, NULL, ZERO);
  if (function != NULL)
    XtAddCallback(w, XtNcallback, function, (caddr_t) NULL);
  return w;
}


Widget 
MakeStringBox(parent, name, string)
Widget parent;
String name, string;
{
  Arg args[5];
  Cardinal numargs = 0;
  Widget StringW;

  XtSetArg(args[numargs], XtNeditType, XawtextEdit); numargs++;
  XtSetArg(args[numargs], XtNstring, string); numargs++;

  StringW = XtCreateManagedWidget(name, asciiTextWidgetClass, 
				  parent, args, numargs);
  return(StringW);  
}
 



/*	Function Name: GetString
 *	Description: retrieves the string from a asciiText widget.
 *	Arguments: w - the ascii text widget.
 *	Returns: the filename.
 */

String
GetString(w)
Widget w;
{
  String str;
  Arg arglist[1];
  
  XtSetArg(arglist[0], XtNstring, &str);
  XtGetValues( w, arglist, ONE);
  return(str);
}



/* translate coordinates in application top-level window into coordinates from
   root window origin */

void TranslateCoords(button,x,y,height,width)
Widget button;
Position *x,*y;
Dimension *height;
Dimension *width;
{

   XtTranslateCoords(button,
		    (Position)0,
		    (Position)0,
		    x,y);
   XtVaGetValues(button,XtNheight,height,XtNwidth,width,NULL);
}



/* return the index of a character in a string if the string contains the caracter, else it 
returns -1 */

int rind(s,c)
char *s;
char c;
{
   register int x;
   for (x=strlen(s)-1; x!=-1; x--)
      if(s[x] == c) return x;
   return -1;
}

/* gives the name of a file within the full path of the file */

void getname(path,name)
char *path;
char *name;
{
   register int x;
   x = rind(path,'/');

   strcpy(name, (x == -1 ? path : &path[x+1]));
   return;
}
	 



/* create a child that popups an Xmosaic Window */

void ExecXmosaic(file_name)
char *file_name;
{
   int pid;
   int exist;
   struct stat *buf;
   char *name;

   /* check up if xmosaic executable file exists */

   buf = (struct stat *)malloc(sizeof(struct stat));
   exist = stat(app_resources.xmosaicPath,buf);

   if (exist == -1)
   {  
      perror("*** xmosaicPath resource error !!!\n");
      if (errno == ENOENT)
         fprintf(stderr,"*** The file %s does not exist. Set up the correct value of the xmosaicPath resource in your .Xdefaults file.\n",app_resources.xmosaicPath);
      exit(1);
   }

   free(buf); 
   
   name = (char *)malloc(20);
   getname(app_resources.xmosaicPath,name);

   pid = fork();
   if (pid == -1)
   {
      fprintf(stderr,"Fork() error\n");
      exit(1);
   }
   else if (pid == 0)
   {
      pid = fork();
      if (pid == -1)
      {
	 fprintf(stderr,"Fork() error\n");
	 exit(1);
      }
      else if (pid == 0)  /* child2 ; executes the command */
      {
         execl(app_resources.xmosaicPath,name,file_name,NULL); 
      }
      else  /* child1 for avoiding zombi processes */
      {
	 exit(0);
      }
   }

   else  /* parent  */
   {
      wait(0);
      free(name);
   }
}



/*	Function Name: MaybeCreateFile
 *	Description: Checks to see if file exists, and if no creates it.
 *	Arguments: file - name of file to check.
 *	Returns: none.
 */

FileAccess
MaybeCreateFile(file)
char * file;
{
    Boolean exists;

/*
 * If file doesn't exit create it.
 */

    if (access(file, F_OK) != 0) 
	creat(file, 0777);

    return(CheckFilePermissions(file, &exists));
}


FileAccess
CheckFilePermissions(file, exists)
char * file;
Boolean *exists;
{
    char temp[BUFSIZ], *ptr;

    if (access(file, F_OK) == 0) {
	*exists = TRUE;

	if (access(file, R_OK) != 0) 
	    return(NO_READ);
	
	if (access(file, R_OK | W_OK) == 0) 
	    return(WRITE_OK);
	return(READ_OK);
    }

    *exists = FALSE;
    
    strcpy(temp, file);
    if ( (ptr = rindex(temp, '/')) == NULL) 
	strcpy(temp, ".");
    else 
	*ptr = '\0';
    
    if (access(temp, R_OK | W_OK | X_OK) == 0)
	return(WRITE_OK);
    return(NO_READ);
}

