

/* $XConsortium: xedit.c,v 1.27 91/02/17 15:48:25 dave Exp $ */
 
/*
 *			  COPYRIGHT 1987
 *		   DIGITAL EQUIPMENT CORPORATION
 *		       MAYNARD, MASSACHUSETTS
 *			ALL RIGHTS RESERVED.
 *
 * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
 * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
 * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE FOR
 * ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
 *
 * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT RIGHTS,
 * APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN ADDITION TO THAT
 * SET FORTH ABOVE.
 *
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Digital Equipment Corporation not be 
 * used in advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.
 */







/**********************************************************************************/
/*                            xhtmledit.c                                         */
/*                      based on the old xedit.c                                  */
/*       modified on 15.11.93 by Sorina COTISEL (cotisel@imag.fr)                 */
/*  Mediatheque IMAG - BP 53X, 38041 GRENOBLE Cedex - mediatheque@imag.fr         */
/*  http://ftpmedia.imag.fr/anteserveur/imag                                      */
/*                                                                                */
/*                                                                                */
/*  modified on 1.03.94 for the second version xhtmledit-1.1                      */
/*                                                                                */
/*  The widget top has been declared as global variable                           */
/**********************************************************************************/



#include "xhtmledit.h"

static XtActionsRec actions[] = {
{"quit", DoQuit},
{"placeMenu", PlaceMenu},
{"checkRightAndPopupSubmenu",CheckRightAndPopupSubmenu},
{"popdownSubmenuOther",PopdownSubmenuOther},
{"popdownSubmenuLogicalStyle",PopdownSubmenuLogicalStyle},
{"writeMessage",WriteMessage},
};

static Atom wm_delete_window;
Display *CurDpy;
Widget top;
extern String name_anchor,img_string,nameRel_anchor,name_img;

void ResetSourceChanged();

struct _app_resources app_resources;

#define Offset(field) XtOffsetOf(struct _app_resources, field)

static XtResource resources[] = {
   {"enableBackups", "EnableBackups", XtRBoolean, sizeof(Boolean),
         Offset(enableBackups), XtRImmediate, FALSE},
   {"backupNamePrefix", "BackupNamePrefix", XtRString, sizeof(char *),
         Offset(backupNamePrefix),XtRString, ""},
   {"backupNameSuffix", "BackupNameSuffix", XtRString, sizeof(char *),
         Offset(backupNameSuffix),XtRString, ".BAK"},
   {"xmosaicPath", "XmosaicPath", XtRString, sizeof(char *),
	 Offset(xmosaicPath), XtRString, "/usr/local/bin/Mosaic"},
   {"helpGeneralPath", "HelpGeneralPath", XtRString, sizeof(char *),
	 Offset(helpGeneralPath), XtRString, "xhtmledit.help_gnrl.html"},
   {"helpHTMLPath", "HelpHTMLPath", XtRString, sizeof(char *),
	 Offset(helpHTMLPath), XtRString,
         "http://www.ncsa.uiuc.edu/demoweb/html_primer.html"},
};

#undef Offset


/* main */

void
main(argc, argv)
int argc;
char **argv;
{
  XtAppContext appcon;
/*--  Widget top; */
  String filename = NULL;

  name_anchor = (char *)malloc(50);
  name_anchor[0] = '\0';
  img_string = (char *)malloc(50);
  img_string[0] = '\0';
  nameRel_anchor = (char *)malloc(50);
  nameRel_anchor[0] = '\0';
  name_img = (char *)malloc(50);
  name_img[0] = '\0';

  top = XtAppInitialize(&appcon, "Xhtmledit", NULL, 0, &argc, argv, NULL, NULL, 0);

  XtAppAddActions(appcon, actions, XtNumber(actions));
  XtOverrideTranslations
      (top, XtParseTranslationTable ("<Message>WM_PROTOCOLS: quit()"));
  
  XtGetApplicationResources(top, (XtPointer) &app_resources, resources,
			    XtNumber(resources), NULL, 0);

  CurDpy = XtDisplay(top);

  if (argc > 1) {
    Boolean exists;
    filename = argv[1];

    switch ( CheckFilePermissions(filename, &exists)) {
    case NO_READ:
	if (exists)
	    fprintf(stderr, 
		    "File %s exists, and could not opened for reading.\n", 
		    filename);
	else
	    fprintf(stderr, "File %s %s %s",  filename, "does not exist,",
		    "and the directory could not be opened for writing.\n");
	exit(1);
    case READ_OK:
    case WRITE_OK:
	makeButtonsAndBoxes(top, filename);
	break;
    default:
	fprintf(stderr, "%s %s", "Internal function MaybeCreateFile()",
		"returned unexpected value.\n");
	exit(1);
    }
  }  
  else
      makeButtonsAndBoxes(top, NULL);

  XtRealizeWidget(top);
  XDefineCursor(XtDisplay(top),XtWindow(top),
		XCreateFontCursor( XtDisplay(top), XC_left_ptr));
  
  wm_delete_window = XInternAtom(XtDisplay(top), "WM_DELETE_WINDOW",
				 False);
  (void) XSetWMProtocols (XtDisplay(top), XtWindow(top),
			  &wm_delete_window, 1);
  XtAppMainLoop(appcon);
}




/*   Function Name: Feep
 *   Description: feeps the bell.
 *   Arguments: none.
 *   Returns: none.
 */

 void
 Feep()
 {
   XBell(CurDpy,0);
 }
