/*
 *	rcs_id[] = "$XConsortium: xedit.h,v 1.19 89/10/07 14:59:46 kit Exp $";
 */
 
 /*
 *			  COPYRIGHT 1987 
 *		   DIGITAL EQUIPMENT CORPORATION 
 *		       MAYNARD, MASSACHUSETTS
 *			ALL RIGHTS RESERVED.
 *
 * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
 * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
 * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE FOR
 * ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
 *
 * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT RIGHTS,
 * APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN ADDITION TO THAT
 * SET FORTH ABOVE.
 *
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Digital Equipment Corporation not be 
 * used in advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.
 */





/**********************************************************************************/
/*                            xhtmledit.h                                         */
/*                      based on the old xedit.h                                  */
/*         modified on 15.11.93 by Sorina COTISEL (cotisel@imag.fr)               */
/*   Mediatheque IMAG - BP 53X, 38041 GRENOBLE Cedex - mediatheque@imag.fr        */
/*                                                                                */
/*                                                                                */
/*   modified on 1.03.94 by Sorina COTISEL for the second version xhtmledit-1.1   */
/*                                                                                */     
/*     - removed functions: PlaceMenuHypertext(), EndAnchor()                     */
/*     - added functions: makeButton(), makeWarning()                             */
/*     - changed names: makeVers() became makeButtonVers()                        */
/*	                WriteHypertext() became WriteImgSrc()                     */
/*   modified on 15.03.94 by Sorina COTISEL for the third version xhtmledit-1.2   */
/*     - added module transform.c                                                 */
/**********************************************************************************/


#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/cursorfont.h>
#include <X11/Xatom.h>

#include <X11/Shell.h>

#include <X11/Xaw/Box.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Dialog.h>
#include <X11/keysymdef.h>


#define MENU_FILE    0
#define MENU_ANCHOR  1
#define MENU_IMG     2
#define MENU_HEADER  3
#define MENU_STYLE   4
#define MENU_LIST    5
#define MENU_MARK    6
#define MENU_SPCHAR  7
#define MENU_ACCENT  8
#define MENU_OTHER   9
#define MENU_HELP    10
#define MENU_DISPLAY 11

#define N_FILE       3
#define N_ANCHOR     7
#define N_IMG        2
#define N_HEADER     6
#define N_STYLE      5
#define N_LSTYLE     8
#define N_LIST       8
#define N_MARK      10
#define N_SPCHAR     4
#define N_ACCENT     5
#define N_OTHER      5
#define N_HELP       2
#define N_DISPLAY    2


extern struct _app_resources {
    Boolean enableBackups;
    char *backupNamePrefix;
    char *backupNameSuffix;
    char *xmosaicPath;
    char *helpGeneralPath;
    char *helpHTMLPath;
} app_resources;

typedef enum {NO_READ, READ_OK, WRITE_OK} FileAccess;

/*	externals in xhtmledit.c 	*/

extern void Feep();

/*      externals in create.c  */

extern Widget makeMenu();
extern Widget makeDialog();
extern Widget makeButtonVers();
extern Widget makeButton();

extern  void makeButtonsAndBoxes();
extern  void makeMenuAnchor();
extern  void makeMenuImg();
extern  void makeMenuFile();
extern  void makeDialogBox();
extern  void makeDialogAnchor();
extern  void makeDialogAnchorNameRel();
extern  void makeDialogImg();
extern  void makeMenuAndCallbacks();
extern  void makeSubMenuOther();
extern  void makeSubMenuLogicalStyle();
extern  void makeVersion();
extern  void makeWarning();
extern  void makeMenuHelp();
extern  void makeMenuDisplay();


/*	externals in util.c 	*/

extern void   XeditPrintf();
extern Widget MakeCommandButton();
extern Widget MakeStringBox();
extern void TranslateCoords();
extern String GetString();
extern int rind();
extern void getname();
extern void ExecXmosaic();
extern FileAccess MaybeCreateFile(), CheckFilePermissions();

/*	externs in commands.c 	*/

extern void PopupDialog();
extern void DialogDone();
extern void WriteAnchor();
extern void WriteImgString();
extern void Done();
extern void DialogCancel();
extern void PlaceMenu();
extern void CheckRightAndPopupSubmenu();
extern void PopdownSubmenuOther();
extern void PopdownSubmenuLogicalStyle();
extern void PaneChosen();
extern void Pane();
extern void WriteMark();
extern void PopupWarning();
extern void DoMark();
extern void DoCheckup();
extern void DoHelp();
extern void ShowVers();
extern void QuitButton();
extern void DisplayFile();
extern void WriteMessage();
extern void DoCut();
extern void DoQuit();
extern void DoSave();
extern void DoLoad();

/*   externs in transform.c   */

extern void InitTabChar();
extern char *Transform();
extern void TransformHTML();
extern void TransformISO_LATIN();

/*   externs in ressources.c  */

void makeTranslations();
void makeDialogLabels();



typedef struct WidgetDone
{
   Widget wid;
   int i;
} WidgetDone;
